package com.example.azuretranslation;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

import androidx.annotation.NonNull;

import java.util.ArrayList;

class DBHelper extends SQLiteOpenHelper {

    final static String TABLENAME = "translations";
    ArrayList<Translations> arr = new ArrayList<>();
    public DBHelper(Context context) {
        // конструктор суперкласса
        super(context, "myDB", null, 1);
    }

    public void add(String lang1, String lang2)
    {
        SQLiteDatabase db = this.getWritableDatabase();
        ContentValues cv = new ContentValues();
        cv.put("lang1", lang1);
        cv.put("lang2", lang2);
        long rowID = db.insert(TABLENAME, null, cv);
        read();
    }

    private void read()
    {
        SQLiteDatabase db = this.getWritableDatabase();
        Cursor c = db.query(TABLENAME, null, null, null, null, null, null);
        arr.clear();
        if (c.moveToFirst()) {

            int id = c.getColumnIndex("id");
            int lang1 = c.getColumnIndex("lang1");
            int lang2 = c.getColumnIndex("lang2");
            int date = c.getColumnIndex("date");
            do {
                arr.add(new Translations(c.getInt(id), c.getString(lang1), c.getString(lang2), c.getString(date)));
            } while (c.moveToNext());
        } else
        c.close();
    }

    public ArrayList<Translations> getTranslations() {
        read();
        return arr;
    }

    @Override
    public void onCreate(SQLiteDatabase db) {
        // создаем таблицу с полями
        db.execSQL("create table translations ("
                + "id integer primary key autoincrement,"
                + "date TIMESTAMP DEFAULT CURRENT_TIMESTAMP ,"
                + "lang1 text,"
                + "lang2 text" + ");");
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {

    }

    class Translations
    {
        int id;
        String date, lang1, lang2;

        public Translations(int id ,String date, String lang1, String lang2) {
            this.id = id;
            this.date = date;
            this.lang1 = lang1;
            this.lang2 = lang2;
        }

        @NonNull
        @Override
        public String toString() {
            return date + ":"  + lang1 + " - " + lang2;
        }
    }
}
